/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.35 Revision 1.125
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.35 2009/05/23 01:08:26 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.125 2012/04/19 14:52:12 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
11# @DESCRIPTION: 9# @DESCRIPTION:
12# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
13 11
14inherit eutils multilib toolchain-funcs flag-o-matic versionator
15
16IUSE="${IUSE} custom-cxxflags debug pch"
17
18case "${PV}" in 12case ${EAPI} in
19 4.?.?_rc*) 13 2|3|4) : ;;
20 SRCTYPE="${SRCTYPE:-opensource-src}" 14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
17inherit base eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
28
21 MY_PV="${PV/_rc/-rc}" 29MY_PV=${PV/_/-}
30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH="${PV%.9999}"
22 ;; 37 ;;
23 *) 38 release)
24 SRCTYPE="${SRCTYPE:-opensource-src}" 39 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
25 MY_PV="${PV}"
26 ;; 40 ;;
27esac 41esac
28MY_P=qt-x11-${SRCTYPE}-${MY_PV} 42
43IUSE="aqua debug pch"
44if [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]]; then
45 IUSE+=" +exceptions"
46fi
47if version_is_at_least 4.8; then
48 IUSE+=" c++0x qpa"
49fi
50
51DEPEND="dev-util/pkgconfig"
52if [[ ${QT4_BUILD_TYPE} == live ]]; then
53 DEPEND+=" dev-lang/perl"
54fi
55
56RDEPEND="
57 !<x11-libs/qt-assistant-${PV}
58 !>x11-libs/qt-assistant-${PV}-r9999
59 !<x11-libs/qt-bearer-${PV}
60 !>x11-libs/qt-bearer-${PV}-r9999
61 !<x11-libs/qt-core-${PV}
62 !>x11-libs/qt-core-${PV}-r9999
63 !<x11-libs/qt-dbus-${PV}
64 !>x11-libs/qt-dbus-${PV}-r9999
65 !<x11-libs/qt-declarative-${PV}
66 !>x11-libs/qt-declarative-${PV}-r9999
67 !<x11-libs/qt-demo-${PV}
68 !>x11-libs/qt-demo-${PV}-r9999
69 !<x11-libs/qt-gui-${PV}
70 !>x11-libs/qt-gui-${PV}-r9999
71 !<x11-libs/qt-multimedia-${PV}
72 !>x11-libs/qt-multimedia-${PV}-r9999
73 !<x11-libs/qt-opengl-${PV}
74 !>x11-libs/qt-opengl-${PV}-r9999
75 !<x11-libs/qt-openvg-${PV}
76 !>x11-libs/qt-openvg-${PV}-r9999
77 !<x11-libs/qt-phonon-${PV}
78 !>x11-libs/qt-phonon-${PV}-r9999
79 !<x11-libs/qt-qt3support-${PV}
80 !>x11-libs/qt-qt3support-${PV}-r9999
81 !<x11-libs/qt-script-${PV}
82 !>x11-libs/qt-script-${PV}-r9999
83 !<x11-libs/qt-sql-${PV}
84 !>x11-libs/qt-sql-${PV}-r9999
85 !<x11-libs/qt-svg-${PV}
86 !>x11-libs/qt-svg-${PV}-r9999
87 !<x11-libs/qt-test-${PV}
88 !>x11-libs/qt-test-${PV}-r9999
89 !<x11-libs/qt-webkit-${PV}
90 !>x11-libs/qt-webkit-${PV}-r9999
91 !<x11-libs/qt-xmlpatterns-${PV}
92 !>x11-libs/qt-xmlpatterns-${PV}-r9999
93"
94
29S=${WORKDIR}/${MY_P} 95S=${WORKDIR}/${MY_P}
30 96
31HOMEPAGE="http://www.qtsoftware.com/"
32SRC_URI="http://download.qtsoftware.com/qt/source/${MY_P}.tar.bz2"
33
34case "${PV}" in
35 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
36 *) ;;
37esac
38
39if version_is_at_least 4.5 ${PV} ; then
40 LICENSE="|| ( LGPL-2.1 GPL-3 )"
41fi
42
43# @FUNCTION: qt4-build_pkg_setup 97# @FUNCTION: qt4-build_pkg_setup
44# @DESCRIPTION: 98# @DESCRIPTION:
45# Sets up installation directories, PLATFORM, PATH, and LD_LIBRARY_PATH 99# Sets up PATH and LD_LIBRARY_PATH.
46qt4-build_pkg_setup() { 100qt4-build_pkg_setup() {
47 # EAPI=2 ebuilds set use-deps, others need this: 101 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
48 if [[ $EAPI != 2 ]]; then 102
49 # Make sure debug setting corresponds with qt-core (bug 258512) 103 # Protect users by not allowing downgrades between releases
50 if [[ $PN != "qt-core" ]]; then 104 # Downgrading revisions within the same release should be allowed
51 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 105 if has_version '>'${CATEGORY}/${P}-r9999; then
52 ~x11-libs/qt-core-${PV} debug" 106 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
107 eerror
108 eerror "Sanity check to keep you from breaking your system:"
109 eerror " Downgrading Qt is completely unsupported and will break your system!"
110 eerror
111 die "aborting to save your system"
112 else
113 ewarn "Downgrading Qt is completely unsupported and will break your system!"
53 fi 114 fi
115 fi
54 116
55 # Check USE requirements 117 if [[ ${PN} == qt-webkit ]]; then
56 qt4-build_check_use 118 eshopts_push -s extglob
119 if is-flagq '-g?(gdb)?([1-9])'; then
120 echo
121 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
122 ewarn "You may experience really long compilation times and/or increased memory usage."
123 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
124 ewarn "For more info check out bug #307861"
125 echo
57 fi 126 fi
58 # Set up installation directories 127 eshopts_pop
59 QTBASEDIR=/usr/$(get_libdir)/qt4 128 fi
60 QTPREFIXDIR=/usr
61 QTBINDIR=/usr/bin
62 QTLIBDIR=/usr/$(get_libdir)/qt4
63 QTPCDIR=/usr/$(get_libdir)/pkgconfig
64 QTDATADIR=/usr/share/qt4
65 QTDOCDIR=/usr/share/doc/qt-${PV}
66 QTHEADERDIR=/usr/include/qt4
67 QTPLUGINDIR=${QTLIBDIR}/plugins
68 QTSYSCONFDIR=/etc/qt4
69 QTTRANSDIR=${QTDATADIR}/translations
70 QTEXAMPLESDIR=${QTDATADIR}/examples
71 QTDEMOSDIR=${QTDATADIR}/demos
72 129
73 PLATFORM=$(qt_mkspecs_dir)
74
75 PATH="${S}/bin:${PATH}" 130 PATH="${S}/bin${PATH:+:}${PATH}"
131 if [[ ${CHOST} != *-darwin* ]]; then
76 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 132 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
133 else
134 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
135 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
136 # platform detection. Note: needs to come before any directories to
137 # avoid extract failure.
138 [[ ${CHOST} == *-apple-darwin* ]] && \
139 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
140 ${QT4_EXTRACT_DIRECTORIES}"
141 fi
77 142
78 if ! version_is_at_least 4.1 $(gcc-version) ; then 143 if ! version_is_at_least 4.1 $(gcc-version); then
79 ewarn "Using a GCC version lower than 4.1 is not supported!" 144 ewarn "Using a GCC version lower than 4.1 is not supported."
80 echo
81 ebeep 3
82 fi 145 fi
83
84 if use custom-cxxflags; then
85 echo
86 ewarn "You have set USE=custom-cxxflags, which means Qt will be built with the"
87 ewarn "CXXFLAGS you have set in /etc/make.conf. This is not supported, and we"
88 ewarn "recommend to unset this useflag. But you are free to experiment with it."
89 ewarn "Just do not start crying if it breaks your system, or eats your kitten"
90 ewarn "for breakfast. ;-) "
91 echo
92 fi
93
94} 146}
95 147
96# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 148# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
97# @DESCRIPTION: 149# @DESCRIPTION:
98# Arguments for build_target_directories. Takes the directories, in which the 150# Arguments for build_target_directories. Takes the directories in which the
99# code should be compiled. This is a space-separated list 151# code should be compiled. This is a space-separated list.
100 152
101# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 153# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
102# @DESCRIPTION: 154# @DESCRIPTION:
103# Space separated list including the directories that will be extracted from Qt 155# Space-separated list including the directories that will be extracted from
104# tarball 156# Qt tarball.
105 157
106# @FUNCTION: qt4-build_src_unpack 158# @FUNCTION: qt4-build_src_unpack
107# @DESCRIPTION: 159# @DESCRIPTION:
108# Unpacks the sources 160# Unpacks the sources.
109qt4-build_src_unpack() { 161qt4-build_src_unpack() {
110 local target targets licenses 162 setqtenv
111 if version_is_at_least 4.5 ${PV} ; then 163
112 licenses="LICENSE.GPL3 LICENSE.LGPL" 164 case ${QT4_BUILD_TYPE} in
113 else 165 live)
114 licenses="LICENSE.GPL2 LICENSE.GPL3" 166 git-2_src_unpack
115 fi 167 ;;
116 for target in configure ${licenses} projects.pro \ 168 release)
169 local tarball="${MY_P}.tar.gz" target= targets=
170 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
117 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 171 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
118 ${QT4_EXTRACT_DIRECTORIES}; do 172 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
173 do
119 targets="${targets} ${MY_P}/${target}" 174 targets+="${MY_P}/${target} "
120 done 175 done
121 176
122 echo tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 177 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
123 tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 178 tar -xzf "${DISTDIR}/${tarball}" ${targets}
124 179 eend $? || die "failed to unpack"
125 case "${PV}" in
126 4.4.?)
127 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
128 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
129 ;; 180 ;;
130 esac 181 esac
131
132 # Be backwards compatible for now
133 if [[ $EAPI != 2 ]]; then
134 qt4-build_src_prepare
135 fi
136} 182}
137 183
184# @ECLASS-VARIABLE: PATCHES
185# @DEFAULT_UNSET
186# @DESCRIPTION:
187# PATCHES array variable containing all various patches to be applied.
188# This variable is expected to be defined in global scope of ebuild.
189# Make sure to specify the full path. This variable is utilised in
190# src_unpack/src_prepare phase, based on EAPI.
191#
192# @CODE
193# PATCHES=( "${FILESDIR}/mypatch.patch"
194# "${FILESDIR}/patches_folder/" )
195# @CODE
138 196
139# @FUNCTION: qt4-build_src_prepare 197# @FUNCTION: qt4-build_src_prepare
140# @DESCRIPTION: 198# @DESCRIPTION:
141# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 199# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
142# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 200# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
143qt4-build_src_prepare() { 201qt4-build_src_prepare() {
144 cd "${S}" 202 setqtenv
203
204 if [[ ${QT4_BUILD_TYPE} == live ]]; then
205 QTDIR="." ./bin/syncqt || die "syncqt failed"
206 fi
207
208 if version_is_at_least 4.7; then
209 # fix libX11 dependency on non X packages
210 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
211 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
212
213 qt_assistant_cleanup
214 fi
215
216 if use aqua; then
217 # provide a proper macx-g++-64
218 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
219
220 sed -e '/^CONFIG/s:app_bundle::' \
221 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
222 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
223 fi
145 224
146 if [[ ${PN} != qt-core ]]; then 225 if [[ ${PN} != qt-core ]]; then
147 skip_qmake_build_patch 226 skip_qmake_build
148 skip_project_generation_patch 227 skip_project_generation
149 symlink_binaries_to_buildtree 228 symlink_binaries_to_buildtree
150 fi 229 fi
151 230
152 if ! use custom-cxxflags;then 231 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
153 # Don't let the user go too overboard with flags. 232 # qmake bus errors with -O2 or -O3 but -O1 works
154 strip-flags 233 # Bug 373061
155 replace-flags -O3 -O2 234 replace-flags -O[23] -O1
156 fi 235 fi
157 236
158 # Bug 178652 237 # Bug 178652
159 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 238 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
160 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 239 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
161 append-flags -fno-gcse 240 append-flags -fno-gcse
162 fi 241 fi
163 242
243 if use_if_iuse c++0x; then
244 echo
245 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
246 ewarn "this is an official standard, some of the reverse dependencies"
247 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
248 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
249 ewarn "disabled."
250 echo
251 append-flags -std=c++0x
252 fi
253
164 # Unsupported old gcc versions - hardened needs this :( 254 # Unsupported old gcc versions - hardened needs this :(
165 if [[ $(gcc-major-version) -lt "4" ]] ; then 255 if [[ $(gcc-major-version) -lt 4 ]]; then
166 ewarn "Appending -fno-stack-protector to CXXFLAGS" 256 ewarn "Appending -fno-stack-protector to CXXFLAGS"
167 append-cxxflags -fno-stack-protector 257 append-cxxflags -fno-stack-protector
168 # Bug 253127 258 # Bug 253127
169 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 259 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
170 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 260 -i mkspecs/common/g++.conf || die
171 fi 261 fi
262
263 # Bug 261632
264 if use ppc64; then
265 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
266 append-flags -mminimal-toc
267 fi
268
269 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
270 sed -e "/^SYSTEM_VARIABLES=/i \
271 CC='$(tc-getCC)'\n\
272 CXX='$(tc-getCXX)'\n\
273 CFLAGS='${CFLAGS}'\n\
274 CXXFLAGS='${CXXFLAGS}'\n\
275 LDFLAGS='${LDFLAGS}'\n" \
276 -i configure \
277 || die "sed SYSTEM_VARIABLES failed"
278
279 # Respect CC, CXX, LINK and *FLAGS in config.tests
280 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
281 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
282 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
283 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
284 || die "sed config.tests failed"
285
286 # Strip predefined CFLAGS from mkspecs (bug 312689)
287 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
172 288
173 # Bug 172219 289 # Bug 172219
290 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
291
292 if [[ ${CHOST} == *-darwin* ]]; then
293 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
294 # crippled (by design) :/
295 local mac_gpp_conf=
296 if [[ -f mkspecs/common/mac-g++.conf ]]; then
297 # qt < 4.8 has mac-g++.conf
298 mac_gpp_conf="mkspecs/common/mac-g++.conf"
299 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
300 # qt >= 4.8 has g++-macx.conf
301 mac_gpp_conf="mkspecs/common/g++-macx.conf"
302 else
303 die "no known conf file for mac found"
304 fi
305 sed \
174 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 306 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
175 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 307 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
176 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 308 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
177 -e "s:X11R6/::" \ 309 -e "s:-arch\s\w*::g" \
178 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 310 -i ${mac_gpp_conf} \
311 || die "sed ${mac_gpp_conf} failed"
179 312
180 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 313 # Fix configure's -arch settings that appear in qmake/Makefile and also
181 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 314 # fix arch handling (automagically duplicates our -arch arg and breaks
182 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 315 # pch). Additionally disable Xarch support.
183 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 316 local mac_gcc_confs="${mac_gpp_conf}"
317 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
318 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
319 fi
320 sed \
321 -e "s:-arch i386::" \
322 -e "s:-arch ppc::" \
323 -e "s:-arch x86_64::" \
324 -e "s:-arch ppc64::" \
325 -e "s:-arch \$i::" \
326 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
327 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
328 -e "s:-Xarch_x86_64::g" \
329 -e "s:-Xarch_ppc64::g" \
330 -i configure ${mac_gcc_confs} \
331 || die "sed -arch/-Xarch failed"
184 332
333 # On Snow Leopard don't fall back to 10.5 deployment target.
334 if [[ ${CHOST} == *-apple-darwin10 ]]; then
335 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
336 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
337 -i configure ${mac_gpp_conf} \
338 || die "sed deployment target failed"
339 fi
340 fi
341
342 # this one is needed for all systems with a separate -liconv, apart from
343 # Darwin, for which the sources already cater for -liconv
344 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
345 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
346 -i config.tests/unix/iconv/iconv.pro \
347 || die "sed iconv.pro failed"
348 fi
349
350 # we need some patches for Solaris
351 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
352 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
353 # use GCC over SunStudio
354 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
355 # do not flirt with non-Prefix stuff, we're quite possessive
356 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
357 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
358
359 base_src_prepare
185} 360}
186 361
187# @FUNCTION: qt4-build_src_configure 362# @FUNCTION: qt4-build_src_configure
188# @DESCRIPTION: 363# @DESCRIPTION:
189# Default configure phase 364# Default configure phase
190qt4-build_src_configure() { 365qt4-build_src_configure() {
366 setqtenv
191 367
192 myconf="$(standard_configure_options) ${myconf}"
193
194 echo ./configure ${myconf}
195 ./configure ${myconf} || die "./configure failed"
196}
197
198# @FUNCTION: qt4-build_src_compile
199# @DESCRIPTION: Actual compile phase
200qt4-build_src_compile() {
201 # Be backwards compatible for now
202 if [[ $EAPI != 2 ]]; then
203 qt4-build_src_configure
204 fi
205
206 build_directories "${QT4_TARGET_DIRECTORIES}"
207}
208
209# @FUNCTION: qt4-build_src_install
210# @DESCRIPTION:
211# Perform the actual installation including some library fixes.
212qt4-build_src_install() {
213 install_directories "${QT4_TARGET_DIRECTORIES}"
214 install_qconfigs
215 fix_library_files
216}
217
218# @FUNCTION: standard_configure_options
219# @DESCRIPTION:
220# Sets up some standard configure options, like libdir (if necessary), whether
221# debug info is wanted or not.
222standard_configure_options() {
223 local myconf="" 368 local conf="
224 369 -prefix ${QTPREFIXDIR}
225 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 370 -bindir ${QTBINDIR}
226 371 -libdir ${QTLIBDIR}
227 # Disable visibility explicitly if gcc version isn't 4 372 -docdir ${QTDOCDIR}
228 if [[ "$(gcc-major-version)" -lt "4" ]]; then 373 -headerdir ${QTHEADERDIR}
229 myconf="${myconf} -no-reduce-exports" 374 -plugindir ${QTPLUGINDIR}
230 fi 375 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
231 376 -datadir ${QTDATADIR}
232 # precompiled headers doesn't work on hardened, where the flag is masked. 377 -translationdir ${QTTRANSDIR}
233 if use pch; then 378 -sysconfdir ${QTSYSCONFDIR}
234 myconf="${myconf} -pch" 379 -examplesdir ${QTEXAMPLESDIR}
235 else 380 -demosdir ${QTDEMOSDIR}
236 myconf="${myconf} -no-pch" 381 -opensource -confirm-license
237 fi 382 -shared -fast -largefile -stl -verbose
238 383 -nomake examples -nomake demos"
239 if use debug; then
240 myconf="${myconf} -debug -no-separate-debug-info"
241 else
242 myconf="${myconf} -release -no-separate-debug-info"
243 fi
244 384
245 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 385 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
246 # $(tc-arch). Therefore we convert it to supported values. 386 # $(tc-arch). Therefore we convert it to supported values.
247 case "$(tc-arch)" in 387 case "$(tc-arch)" in
248 amd64) myconf="${myconf} -arch x86_64" ;; 388 amd64|x64-*) conf+=" -arch x86_64" ;;
389 ppc-macos) conf+=" -arch ppc" ;;
249 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 390 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
391 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
392 x86-macos) conf+=" -arch x86" ;;
250 x86|x86-*) myconf="${myconf} -arch i386" ;; 393 x86|x86-*) conf+=" -arch i386" ;;
251 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 394 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
252 hppa|sh) myconf="${myconf} -arch generic" ;; 395 hppa|sh) conf+=" -arch generic" ;;
253 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 396 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
254 esac 397 esac
255 398
256 # Bug 261412 Qt configure detects archs by uname 399 conf+=" -platform $(qt_mkspecs_dir)"
257 case "$(tc-arch)" in
258 ppc) myconf="${myconf} -platform linux-g++-32";;
259 esac
260 400
261 myconf="${myconf} -stl -verbose -largefile -confirm-license -no-rpath 401 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
262 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
263 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
264 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
265 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
266 -demosdir ${QTDEMOSDIR} -silent -fast
267 $([[ ${PN} == qt-xmlpatterns ]] || echo -no-exceptions)
268 -reduce-relocations -nomake examples -nomake demos"
269
270 # Make eclass 4.5.{1,2} ready
271 case "${MY_PV}" in
272 4.5.1 | 4.5.2)
273 myconf="${myconf} -opensource"
274 ;;
275 esac
276 402
403 # debug/release
404 if use debug; then
405 conf+=" -debug"
406 else
407 conf+=" -release"
408 fi
409 conf+=" -no-separate-debug-info"
410
411 # exceptions USE flag
412 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
413
414 # disable RPATH on Qt >= 4.8 (bug 380415)
415 version_is_at_least 4.8 && conf+=" -no-rpath"
416
417 # precompiled headers don't work on hardened, where the flag is masked
418 conf+=" $(qt_use pch)"
419
420 # -reduce-relocations
421 # This flag seems to introduce major breakage to applications,
422 # mostly to be seen as a core dump with the message "QPixmap: Must
423 # construct a QApplication before a QPaintDevice" on Solaris.
424 # -- Daniel Vergien
425 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
426
427 # this one is needed for all systems with a separate -liconv, apart from
428 # Darwin, for which the sources already cater for -liconv
429 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
430 conf+=" -liconv"
431 fi
432
433 if use_if_iuse glib; then
434 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
435 # avoid the -pthread argument
436 conf+=" ${glibflags//-pthread}"
437 unset glibflags
438 fi
439
440 if use_if_iuse qpa; then
441 echo
442 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
443 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
444 ewarn "disable it before reporting any bugs related to this useflag."
445 echo
446 conf+=" -qpa"
447 fi
448
449 if use aqua; then
450 # On (snow) leopard use the new (frameworked) cocoa code.
451 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
452 conf+=" -cocoa -framework"
453 # We need the source's headers, not the installed ones.
454 conf+=" -I${S}/include"
455 # Add hint for the framework location.
456 conf+=" -F${QTLIBDIR}"
457
458 # We are crazy and build cocoa + qt3support :-)
459 if use qt3support; then
460 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
461 -i configure || die
462 fi
463 else
464 conf+=" -no-framework"
465 fi
466 else
467 # freetype2 include dir is non-standard, thus pass it to configure
468 conf+=" $(pkg-config --cflags-only-I freetype2)"
469 fi
470
277 echo "${myconf}" 471 conf+=" ${myconf}"
472 myconf=
473
474 echo ./configure ${conf}
475 ./configure ${conf} || die "./configure failed"
476
477 prepare_directories ${QT4_TARGET_DIRECTORIES}
278} 478}
479
480# @FUNCTION: qt4-build_src_compile
481# @DESCRIPTION:
482# Actual compile phase
483qt4-build_src_compile() {
484 setqtenv
485
486 build_directories ${QT4_TARGET_DIRECTORIES}
487}
488
489# @FUNCTION: qt4-build_src_test
490# @DESCRIPTION:
491# Runs tests only in target directories.
492qt4-build_src_test() {
493 # QtMultimedia does not have any test suite (bug #332299)
494 [[ ${PN} == qt-multimedia ]] && return
495
496 for dir in ${QT4_TARGET_DIRECTORIES}; do
497 emake -j1 check -C ${dir}
498 done
499}
500
501# @FUNCTION: fix_includes
502# @DESCRIPTION:
503# For MacOS X we need to add some symlinks when frameworks are
504# being used, to avoid complications with some more or less stupid packages.
505fix_includes() {
506 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
507 # Some packages tend to include <Qt/...>
508 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
509
510 # Fake normal headers when frameworks are installed... eases life later on
511 local dest f h
512 for frw in "${D}${QTLIBDIR}"/*.framework; do
513 [[ -e "${frw}"/Headers ]] || continue
514 f=$(basename ${frw})
515 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
516 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
517
518 # Link normal headers as well.
519 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
520 h=$(basename ${hdr})
521 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
522 done
523 done
524 fi
525}
526
527# @FUNCTION: qt4-build_src_install
528# @DESCRIPTION:
529# Perform the actual installation including some library fixes.
530qt4-build_src_install() {
531 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
532 setqtenv
533
534 install_directories ${QT4_TARGET_DIRECTORIES}
535 install_qconfigs
536 fix_library_files
537 fix_includes
538
539 # remove .la files since we are building only shared Qt libraries
540 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
541}
542
543# @FUNCTION: setqtenv
544# @INTERNAL
545setqtenv() {
546 # Set up installation directories
547 QTPREFIXDIR=${EPREFIX}/usr
548 QTBINDIR=${EPREFIX}/usr/bin
549 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
550 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
551 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
552 QTHEADERDIR=${EPREFIX}/usr/include/qt4
553 QTPLUGINDIR=${QTLIBDIR}/plugins
554 QTIMPORTDIR=${QTLIBDIR}/imports
555 QTDATADIR=${EPREFIX}/usr/share/qt4
556 QTTRANSDIR=${QTDATADIR}/translations
557 QTSYSCONFDIR=${EPREFIX}/etc/qt4
558 QTEXAMPLESDIR=${QTDATADIR}/examples
559 QTDEMOSDIR=${QTDATADIR}/demos
560 QMAKE_LIBDIR_QT=${QTLIBDIR}
561 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
562
563 PLATFORM=$(qt_mkspecs_dir)
564
565 unset QMAKESPEC
566}
567
568# @FUNCTION: prepare_directories
569# @USAGE: < directories >
570# @INTERNAL
571# @DESCRIPTION:
572# Generates Makefiles for the given list of directories.
573prepare_directories() {
574 for x in "$@"; do
575 pushd "${S}"/${x} >/dev/null || die
576 einfo "Running qmake in: ${x}"
577 # avoid running over the maximum argument number, bug #299810
578 {
579 echo "${S}"/mkspecs/common/*.conf
580 find "${S}" -name '*.pr[io]'
581 } | xargs sed -i \
582 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
583 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
584 || die
585 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
586 popd >/dev/null || die
587 done
588}
589
279 590
280# @FUNCTION: build_directories 591# @FUNCTION: build_directories
281# @USAGE: < directories > 592# @USAGE: < directories >
593# @INTERNAL
282# @DESCRIPTION: 594# @DESCRIPTION:
283# Compiles the code in $QT4_TARGET_DIRECTORIES 595# Compiles the code in the given list of directories.
284build_directories() { 596build_directories() {
285 local dirs="$@"
286 for x in ${dirs}; do 597 for x in "$@"; do
287 cd "${S}"/${x} 598 pushd "${S}"/${x} >/dev/null || die
288 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 599 emake CC="$(tc-getCC)" \
289 emake || die "emake failed" 600 CXX="$(tc-getCXX)" \
601 LINK="$(tc-getCXX)" || die "emake failed"
602 popd >/dev/null || die
290 done 603 done
291} 604}
292 605
293# @FUNCTION: install_directories 606# @FUNCTION: install_directories
294# @USAGE: < directories > 607# @USAGE: < directories >
608# @INTERNAL
295# @DESCRIPTION: 609# @DESCRIPTION:
296# run emake install in the given directories, which are separated by spaces 610# Runs emake install in the given directories, which are separated by spaces.
297install_directories() { 611install_directories() {
298 local dirs="$@"
299 for x in ${dirs}; do 612 for x in "$@"; do
300 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 613 pushd "${S}"/${x} >/dev/null || die
301 emake INSTALL_ROOT="${D}" install || die "emake install failed" 614 emake INSTALL_ROOT="${D}" install || die "emake install failed"
302 popd >/dev/null || die "Can't popd from ${S}/${x}" 615 popd >/dev/null || die
303 done 616 done
304} 617}
305 618
306# @ECLASS-VARIABLE: QCONFIG_ADD 619# @ECLASS-VARIABLE: QCONFIG_ADD
307# @DESCRIPTION: 620# @DESCRIPTION:
308# List options that need to be added to QT_CONFIG in qconfig.pri 621# List options that need to be added to QT_CONFIG in qconfig.pri
309QCONFIG_ADD="${QCONFIG_ADD:-}" 622: ${QCONFIG_ADD:=}
310 623
311# @ECLASS-VARIABLE: QCONFIG_REMOVE 624# @ECLASS-VARIABLE: QCONFIG_REMOVE
312# @DESCRIPTION: 625# @DESCRIPTION:
313# List options that need to be removed from QT_CONFIG in qconfig.pri 626# List options that need to be removed from QT_CONFIG in qconfig.pri
314QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 627: ${QCONFIG_REMOVE:=}
315 628
316# @ECLASS-VARIABLE: QCONFIG_DEFINE 629# @ECLASS-VARIABLE: QCONFIG_DEFINE
317# @DESCRIPTION: 630# @DESCRIPTION:
318# List variables that should be defined at the top of QtCore/qconfig.h 631# List variables that should be defined at the top of QtCore/qconfig.h
319QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 632: ${QCONFIG_DEFINE:=}
320 633
321# @FUNCTION: install_qconfigs 634# @FUNCTION: install_qconfigs
635# @INTERNAL
636# @DESCRIPTION:
322# @DESCRIPTION: Install gentoo-specific mkspecs configurations 637# Install gentoo-specific mkspecs configurations.
323install_qconfigs() { 638install_qconfigs() {
324 local x 639 local x
325 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 640 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
326 for x in QCONFIG_ADD QCONFIG_REMOVE; do 641 for x in QCONFIG_ADD QCONFIG_REMOVE; do
327 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 642 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
328 done 643 done
329 insinto ${QTDATADIR}/mkspecs/gentoo 644 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
330 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 645 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
331 fi 646 fi
332 647
333 if [[ -n ${QCONFIG_DEFINE} ]]; then 648 if [[ -n ${QCONFIG_DEFINE} ]]; then
334 for x in ${QCONFIG_DEFINE}; do 649 for x in ${QCONFIG_DEFINE}; do
335 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 650 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
336 done 651 done
337 insinto ${QTHEADERDIR}/Gentoo 652 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
338 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 653 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
339 fi 654 fi
340} 655}
341 656
342# @FUNCTION: generate_qconfigs 657# @FUNCTION: generate_qconfigs
343# @DESCRIPTION: Generates gentoo-specific configurations 658# @INTERNAL
659# @DESCRIPTION:
660# Generates gentoo-specific qconfig.{h,pri}.
344generate_qconfigs() { 661generate_qconfigs() {
345 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 662 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
346 local x qconfig_add qconfig_remove qconfig_new 663 local x qconfig_add qconfig_remove qconfig_new
347 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 664 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
348 [[ -f ${x} ]] || continue 665 [[ -f ${x} ]] || continue
349 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 666 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
350 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 667 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
351 done 668 done
352 669
353 # these error checks do not use die because dying in pkg_post{inst,rm} 670 # these error checks do not use die because dying in pkg_post{inst,rm}
354 # just makes things worse. 671 # just makes things worse.
355 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 672 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
362 679
363 # generate list of QT_CONFIG entries from the existing list 680 # generate list of QT_CONFIG entries from the existing list
364 # including qconfig_add and excluding qconfig_remove 681 # including qconfig_add and excluding qconfig_remove
365 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 682 for x in $(sed -n 's/^QT_CONFIG +=//p' \
366 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 683 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
367 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 684 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
368 done 685 done
369 686
370 # replace the existing QT_CONFIG list with qconfig_new 687 # replace the existing QT_CONFIG list with qconfig_new
371 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 688 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
372 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 689 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
396 fi 713 fi
397 fi 714 fi
398} 715}
399 716
400# @FUNCTION: qt4-build_pkg_postrm 717# @FUNCTION: qt4-build_pkg_postrm
718# @DESCRIPTION:
401# @DESCRIPTION: Generate configurations when the package is completely removed 719# Regenerate configuration when the package is completely removed.
402qt4-build_pkg_postrm() { 720qt4-build_pkg_postrm() {
403 generate_qconfigs 721 generate_qconfigs
404} 722}
405 723
406# @FUNCTION: qt4-build_pkg_postinst 724# @FUNCTION: qt4-build_pkg_postinst
725# @DESCRIPTION:
407# @DESCRIPTION: Generate configuration, plus throws a message about possible 726# Regenerate configuration, plus throw a message about possible
408# breakages and proposed solutions. 727# breakages and proposed solutions.
409qt4-build_pkg_postinst() { 728qt4-build_pkg_postinst() {
410 generate_qconfigs 729 generate_qconfigs
411 echo
412 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
413 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
414 ewarn "should recompile the packages providing these plugins. Also, make sure you"
415 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
416 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
417 ewarn
418 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
419 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
420 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
421 ewarn "configuration."
422 ewarn
423 ewarn "For more information, see http://doc.trolltech.com/4.4/plugins-howto.html"
424 echo
425} 730}
426 731
427# @FUNCTION: skip_qmake_build_patch 732# @FUNCTION: skip_qmake_build
733# @INTERNAL
428# @DESCRIPTION: 734# @DESCRIPTION:
429# Don't need to build qmake, as it's already installed from qt-core 735# Patches configure to skip qmake compilation, as it's already installed by qt-core.
430skip_qmake_build_patch() { 736skip_qmake_build() {
431 # Don't need to build qmake, as it's already installed from qt-core
432 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 737 sed -i -e "s:if true:if false:g" "${S}"/configure || die
433} 738}
434 739
435# @FUNCTION: skip_project_generation_patch 740# @FUNCTION: skip_project_generation
741# @INTERNAL
436# @DESCRIPTION: 742# @DESCRIPTION:
437# Exit the script early by throwing in an exit before all of the .pro files are scanned 743# Exit the script early by throwing in an exit before all of the .pro files are scanned.
438skip_project_generation_patch() { 744skip_project_generation() {
439 # Exit the script early by throwing in an exit before all of the .pro files are scanned
440 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 745 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
441 -i "${S}"/configure || die "Sed failed"
442} 746}
443 747
444# @FUNCTION: symlink_binaries_to_buildtree 748# @FUNCTION: symlink_binaries_to_buildtree
749# @INTERNAL
445# @DESCRIPTION: 750# @DESCRIPTION:
446# Symlink generated binaries to buildtree so they can be used during compilation 751# Symlinks generated binaries to buildtree, so they can be used during compilation time.
447# time
448symlink_binaries_to_buildtree() { 752symlink_binaries_to_buildtree() {
449 for bin in qmake moc uic rcc; do 753 for bin in qmake moc uic rcc; do
450 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 754 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
451 done 755 done
452} 756}
453 757
454# @FUNCTION: fix_library_files 758# @FUNCTION: fix_library_files
759# @INTERNAL
455# @DESCRIPTION: 760# @DESCRIPTION:
456# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 761# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
457# moves the *.pc-files into the pkgconfig directory 762# moves the *.pc files into the pkgconfig directory.
458fix_library_files() { 763fix_library_files() {
764 local libfile
459 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 765 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
460 if [[ -e ${libfile} ]]; then 766 if [[ -e ${libfile} ]]; then
461 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 767 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
462 fi 768 fi
463 done 769 done
464 770
465 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 771 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
466 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 772 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
467 if [[ -e ${libfile} ]]; then 773 if [[ -e ${libfile} ]]; then
468 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 774 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
469 775
470 # Move .pc files into the pkgconfig directory 776 # Move .pc files into the pkgconfig directory
471 dodir ${QTPCDIR} 777 dodir ${QTPCDIR#${EPREFIX}}
472 mv ${libfile} "${D}"/${QTPCDIR}/ \ 778 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
473 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
474 fi 779 fi
475 done 780 done
476 781
477 # Don't install an empty directory 782 # Don't install an empty directory
478 rmdir "${D}"/${QTLIBDIR}/pkgconfig 783 rmdir "${D}"/${QTLIBDIR}/pkgconfig
479} 784}
480 785
481# @FUNCTION: qt_use 786# @FUNCTION: qt_use
482# @USAGE: < flag > [ feature ] [ enableval ] 787# @USAGE: < flag > [ feature ] [ enableval ]
483# @DESCRIPTION: 788# @DESCRIPTION:
484# This will echo "${enableval}-${feature}" if <flag> is enabled, or 789# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
485# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 790# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
486# will be used for that. If [enableval] is not specified, it omits the 791# will be used for that. If [enableval] is not specified, it omits the
487# assignment-part 792# "-${enableval}" part.
488qt_use() { 793qt_use() {
489 local flag="${1}" 794 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
490 local feature="${1}"
491 local enableval=
492
493 [[ -n ${2} ]] && feature=${2}
494 [[ -n ${3} ]] && enableval="-${3}"
495
496 if use ${flag}; then
497 echo "${enableval}-${feature}"
498 else
499 echo "-no-${feature}"
500 fi
501}
502
503# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK
504# @DESCRIPTION:
505# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use
506# (eutils.eclass), line per line.
507#
508# Example:
509# @CODE
510# pkg_setup() {
511# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
512# ~x11-libs/qt-gui-${PV} qt3support"
513# qt4-build_check_use
514# }
515# @CODE
516
517# Run built_with_use on each flag and print appropriate error messages if any
518# flags are missing
519
520_qt_built_with_use() {
521 local missing opt pkg flag flags
522
523 if [[ ${1} = "--missing" ]]; then
524 missing="${1} ${2}" && shift 2
525 fi
526 if [[ ${1:0:1} = "-" ]]; then
527 opt=${1} && shift
528 fi
529
530 pkg=${1} && shift
531
532 for flag in "${@}"; do
533 flags="${flags} ${flag}"
534 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
535 flags="${flags}*"
536 else
537 [[ ${opt} = "-o" ]] && return 0
538 fi
539 done
540 if [[ "${flags# }" = "${@}" ]]; then
541 return 0
542 fi
543 if [[ ${opt} = "-o" ]]; then
544 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
545 else
546 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
547 fi
548 return 1
549}
550
551# @FUNCTION: qt4-build_check_use
552# @DESCRIPTION:
553# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
554# USE flags listed.
555#
556# If any of the required USE flags are missing, an eerror will be printed for
557# each package with missing USE flags.
558qt4-build_check_use() {
559 local line missing
560 while read line; do
561 [[ -z ${line} ]] && continue
562 if ! _qt_built_with_use ${line}; then
563 missing=true
564 fi
565 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
566 if [[ -n ${missing} ]]; then
567 echo
568 eerror "Flags marked with an * are missing."
569 die "Missing USE flags found"
570 fi
571} 795}
572 796
573# @FUNCTION: qt_mkspecs_dir 797# @FUNCTION: qt_mkspecs_dir
574# @RETURN: the specs-directory w/o path 798# @RETURN: the specs-directory w/o path
575# @DESCRIPTION: 799# @DESCRIPTION:
576# Allows us to define which mkspecs dir we want to use. 800# Allows us to define which mkspecs dir we want to use.
577qt_mkspecs_dir() { 801qt_mkspecs_dir() {
578 # Allows us to define which mkspecs dir we want to use.
579 local spec 802 local spec=
580 803
581 case ${CHOST} in 804 case "${CHOST}" in
582 *-freebsd*|*-dragonfly*) 805 *-freebsd*|*-dragonfly*)
583 spec="freebsd" ;; 806 spec=freebsd ;;
584 *-openbsd*) 807 *-openbsd*)
585 spec="openbsd" ;; 808 spec=openbsd ;;
586 *-netbsd*) 809 *-netbsd*)
587 spec="netbsd" ;; 810 spec=netbsd ;;
588 *-darwin*) 811 *-darwin*)
812 if use aqua; then
813 # mac with carbon/cocoa
814 spec=macx
815 else
816 # darwin/mac with x11
589 spec="darwin" ;; 817 spec=darwin
818 fi
819 ;;
820 *-solaris*)
821 spec=solaris ;;
590 *-linux-*|*-linux) 822 *-linux-*|*-linux)
591 spec="linux" ;; 823 spec=linux ;;
592 *) 824 *)
593 die "Unknown CHOST, no platform choosen." 825 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
594 esac 826 esac
595 827
596 CXX=$(tc-getCXX) 828 case "$(tc-getCXX)" in
597 if [[ ${CXX/g++/} != ${CXX} ]]; then 829 *g++*)
598 spec="${spec}-g++" 830 spec+=-g++ ;;
599 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 831 *icpc*)
600 spec="${spec}-icc" 832 spec+=-icc ;;
601 else 833 *)
602 die "Unknown compiler ${CXX}." 834 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
835 esac
836
837 # Add -64 for 64bit profiles
838 if use x64-freebsd ||
839 use amd64-linux ||
840 use x64-macos ||
841 use x64-solaris ||
842 use sparc64-solaris
843 then
844 spec+=-64
603 fi 845 fi
604 846
605 echo "${spec}" 847 echo "${spec}"
606} 848}
607 849
608case ${EAPI:-0} in 850# @FUNCTION: qt_assistant_cleanup
609 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 851# @INTERNAL
852# @DESCRIPTION:
853# Tries to clean up tools.pro for qt-assistant ebuilds.
854# Meant to be called in src_prepare().
855# Since Qt 4.7.4 this function is a no-op.
856qt_assistant_cleanup() {
857 # apply patching to qt-assistant ebuilds only
858 [[ ${PN} != qt-assistant ]] && return
859
860 # no longer needed for 4.7.4 and later
861 version_is_at_least 4.7.4 && return
862
863 # different versions (and branches...) may need different handling,
864 # add a case if you need special handling
865 case "${MY_PV_EXTRA}" in
866 *kde-qt*)
867 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
868 -e "/mac/,/^embedded.*makeqpf$/d" \
869 -i tools/tools.pro || die "patching tools.pro failed"
870 ;;
871 *)
872 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
873 -e "/mac/,/^embedded.*makeqpf$/d" \
874 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
875 -i tools/tools.pro || die "patching tools.pro failed"
876 ;;
877 esac
878}
879
880# @FUNCTION: qt_nolibx11
881# @INTERNAL
882# @DESCRIPTION:
883# Ignore X11 tests for packages that don't need X libraries installed.
884qt_nolibx11() {
885 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
886 die "x11 check sed failed"
887}
888
610 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 889EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
611esac

Legend:
Removed from v.1.35  
changed lines
  Added in v.1.125

  ViewVC Help
Powered by ViewVC 1.1.20